        PAGE            ,132
;
;                       -- bmi.asm --
;            (Boot Manager Installation program)
;
;   Copyright (c) 2001 Efim Tokarevski
;
; You may distribute this file under the terms of the GNU General Public
; License.  See the file COPYING for more information.
;
;
; This file has been compiled, linked and debugged by:
;
; Microsoft (R) Macro Assembler Version 5.10
; Copyright (C) Microsoft Corp 1981, 1988.
;
; Microsoft (R) Segmented-Executable Linker  Version 5.10
; Copyright (C) Microsoft Corp 1984-1990.
;
; Microsoft (R) CodeView (R)  Version 3.00
; Copyright (C) Microsoft Corp 1986-1990.
;
; Probably it is possible to use more modern versions of these tools;-)
;
;
;       Abbreviations used in the comments:
;    MBR_main   - block containing partition table of the whole disc (LBA = 0);
;    MBR_ext    - the same for the logical disc of the extended partition;
;    MBR        - any of above;
;    osBoot     - the first block of any OS loader;
;
;
;

        .SALL
        .386p

MBOOT_ORG       = 0600h                 ;here MBR image resides
FREE_ORG        = MBOOT_ORG + 400h      ;dynamic vars

SPC_YES         = 0EDDEh                ;"Space key is pressed" mark
SPC_NO          = 0ABBAh                ;"Space key is NOT pressed" mark

Menu_x          = 20                    ;-- menu           (col)
Menu_y          = 10                    ;  coordinates     (row)
Menu_xy         = Menu_x + Menu_y * 256

Help_x          = 10                    ;-- help messages  (col)
Help_y          = 17                    ;  coordinates     (row)

NameLng         = 11                    ;-- lengths of
LenLng          = 6                     ;  menu fields

DiscBlockSize   = 512                   ;this is a default value for CHS mode;
                                        ;       (for EDD mode real value may
                                        ;        be received by Int 13-48)

$gen    MACRO p                         ;this makes listing more compact
        p
        ENDM

DPRMS   STRUC                           ;struct for Int 13-48 (not used)
len     DW      1Ah
flgs    DW      0
cyls    DD      0
heads   DD      0
secs    DD      0
totsecs DQ      0
bytpsec DW      0
DPRMS   ENDS

;-- to lessen MBR size there are several patches applied to MBR
;   image during its composition;
;   conditional expressions below prevent those patches to grow beyond
;   their boarders (actually only the last is really needed)
IF2
        IF AddBlk$ - AddBlk LT patchA$ - patchA
        .ERR
        ENDIF
        IF Space$ - Space LT patchS$ - patchS
        .ERR
        ENDIF
        IF blRW_mb$ - blRW_mb LT patchE$ - patchE
        .ERR
        ENDIF
ENDIF




mainSeg SEGMENT         para public 'code' use16
        ASSUME          cs:mainSeg,ds:mainSeg,es:mainSeg,ss:progstack

Begin:  mov ax,cs
        mov ds,ax                       ;ds: = cs:
        cld
        lea dx,legend
        mov ah,09h                      ;print legend
        int 21h

;-- check options of the command line
p01:    mov di,80h
        movzx cx,byte ptr es:[di]       ;cx -command line length
        jcxz exec                       ;--> if there is no command line
        inc di

cl0:    mov al,' '
        repe scasb                      ;search for the first non space symbol
        je exec                         ;--> if all of them are spaces
        cmp byte ptr es: -1[di],'-'
        je short p02
        cmp byte ptr es: -1[di],'/'
        jne short synt

p02:    jcxz synt
        dec cx
        mov al,es:[di]
        or al,20h                       ;set lower case
        cmp al,'m'
        jne short p03
        inc NoKeyFlg                    ;menu should be always shown
        jmp short cl10
p03:    cmp al,'c'
        jne short p04
        mov modeFlg,1                   ;forced CHS mode
        jmp short cl10
p04:    cmp al,'e'
        jne short p05
        mov modeFlg,2                   ;forced EDD mode
        jmp short cl10
p05:    cmp al,'n'
        jne short synt
        inc NoBackupFlg                 ;modified disc sectors
                                        ;        should not be backuped
cl10:   inc di
        jcxz exec
        jmp short cl0

synt:   lea dx,options
        jmp prErr

;-- set initial values to the local variables
exec:   xor ax,ax
        push ds
        mov es,ax                       ;es: = 0
        mov al,es:RowNum
        mov rownum,al
        mov ax,es:ColNum
        mov colnum,al
        mov bl,es:MaxDrives
        or  maxdrives,bl
        pop es                          ;es: = ds:

;-- disc selection
        cmp bl,1
        jbe dskNums                     ;--> if nothing to select
askLoop:lea dx,ask_drive
        mov ah,09h                      ;invite for input
        int 21h
        mov ah,0Ah                      ;wait for input
        lea dx,line
        int 21h
        mov dl,'1'                      ;disc = 1 (default)
        mov al,line+1                   ;al <- # of input chars
        cmp al,0
        je  short p06                   ;--> if no input
        mov dl,line+2                   ;dl <- input char
        cmp dl,'0'
        je short askLoop                ;--> error if disc = 0
p06:    cmp dl,maxdrives
        ja short askLoop                ;--> error if disc > max
        and dl,0Fh
        dec dl
        or  dl,80h
        mov CurrDisc,dl                 ;save BIOS disc id (80h, 81h ..)

;-- put disc number into printable messages
dskNums:mov al,CurrDisc
        and al,0Fh
        inc al
        or  CurrDiscNum1,al
        or  CurrDiscNum2,al

;-- check whether Int 13 Extended Mode (EDD) is maintained for the selected disc
        mov bx,55AAh
        mov dl,CurrDisc
        mov ah,41h
        int 13h
        lea dx,noExt
        jc  short p07           ;--> if no such luck
        cmp bx,0AA55h
        jne short p07           ;--> same
        and cl,1
        jz short p07            ;--> same
        cmp modeFlg,0
        jne short ch_prm        ;--> if mode has been selected by the user
        mov modeFlg,2
        jmp short ch_prm        ;default to EDD mode if it is maintained

p07:    cmp modeFlg,2           ;has EDD mode been requested by the user?
        je prErr                ;--> if yes (Int13 Ext isn't maintained)
        mov modeFlg,1           ;set CHS mode

;-- get disc geometry (for CHS mode)
ch_prm: mov dl,CurrDisc
        mov ah,08h
        int 13h
        mov bx,dx               ;bh <- heads number but one
        lea dx,hdprmErr
        jc prErr                ;--> if error while getting disc geometry
        mov ax,cx
        and ax,3Fh
        mov SecsInHead,ax       ;sectors per track
        inc bh                  ;bh <- heads number
        mul bh
        mov SecsInCyl,ax        ;sectors per cylinder


;================== Main loop (processing of the MBRs) ========================
;
mLoop:  lea bx,buff
        mov ax,0200h
        mov si,word ptr _Base
        mov di,word ptr _Base + 2
        call blRW               ;reading current MBR from disc to buff
        jnc p08                 ;--> if OK
        inc readErrFlg
        jmp prFin               ;--> if disc read error

;-- partition table from loaded MBR goes into the new MBR;
;   eventually this new MBR may replace the loaded one.
p08:    lea si,buff + 01BEh
        lea di,mboot + 01BEh
        mov cx,0200h - 01BEh
        rep movsb

;-- clear variables
        mov MenuInstalled,0
        mov extndPart,0
        mov noOsFlag,0
        mov F4flag,0
        mov F5flag,0

;-- clear menu fields before input
        mov dx,4
        mov al,' '
        lea di,tmplNames
p09:    mov cx,NameLng
        rep stosb
        inc di
        dec dx
        jne p09

        mov dx,4
        mov al,' '
        lea di,tmplLengths
p10:    mov cx,LenLng
        rep stosb
        inc di
        dec dx
        jne p10

;-- check whether loaded MBR has the same format as new MBR
        lea si,buff + (menuMb - mboot)
        lea di,menuMb
        mov cx,menuMb_ - menuMb
        rep cmpsb
        jne clr_scr             ;--> no, some other format
        lea si,buff + (menuMbEnd - mboot)
        lea di,menuMbEnd
        mov cx,menuMbEnd_ - menuMbEnd
        rep cmpsb
        jne clr_scr             ;--> no, some other format

;-- retain OS names of the loaded MBR in the new menu
        mov bx,4
        lea ax,buff + (menuMb0 - mboot)
        lea dx,tmplNames
p11:    mov si,ax
        mov di,dx
        mov cx,NameLng
        rep movsb
        add ax,menuMb1 - menuMb0
        add dx,NameLng + 1
        dec bx
        jne p11
        mov MenuInstalled,1

;-- clear screen
clr_scr:xor cx,cx               ;upper left corner  (row=00,col=00)
        mov dl,colnum           ;lower right corner
        mov dh,rownum
        call clWin
        inc clrScrFlg

;-- initialize current field addresses
pr_menu:lea ax,tmplNums
        mov NumAddr,ax          ;NumAddr -1st menu field
        lea ax,tmplNames
        mov OsAddr,ax           ;OsAddr  -2nd menu field
        lea ax,tmplLengths
        mov LenAddr,ax          ;LenAddr -3rd menu field

        lea bp,tbl              ;bp - partition table address
        xor di,di               ;di - highlighted line number (0-3)
        mov dx,Menu_xy          ;dx - menu coordinates
        mov cx,4                ;cx - line counter

;-- print 1-st menu field (line number)
pm_loop:mov si,NumAddr
        call prHfld
        mov NumAddr,si

;-- print 2-nd menu field (partition name)
        mov si,OsAddr
        cmp MenuInstalled,0     ;does loaded MBR has menu of our format?
        jne p12                 ;--> if yes
        call fill_osname        ;a name from default table -> OS name field
p12:    call prHfld
        mov OsAddr,si

;-- print 3-rd menu field (partition length)
        mov si,LenAddr
        add si,LenLng - 1
        call fill_len           ;length of the partition -> OS length field
        mov si,LenAddr
        call prHfld
        mov LenAddr,si

;-- print "mb"
        lea si,endline
        call prHfld

;-- prepare to print next menu line
        add bp,10h
        inc dh
        mov dl,Menu_x
        inc di
        loop pm_loop

;-- mark that default OS names have been taken
        mov MenuInstalled,1

;-- print help lines
        call clHelp
        mov dh,Help_y
        mov dl,Help_x
        lea si,PressUp
        call prfld
        mov dl,Help_x
        inc dh
        lea si,PressEsc
        call prfld
        mov dl,Help_x
        inc dh
        lea si,PressF3
        call prfld
        cmp MbootCnt,0          ;MBR_main?  ;MBR_main must have
        je prf5                 ;--> if yes ;at least one bootable OS
        lea si,PressF3_
        call prfld
        mov dl,Help_x
        inc dh
        lea si,PressF4
        call prfld
prf5:   mov dl,Help_x
        inc dh
        lea si,PressF5
        call prfld

;-- hide cursor
        mov dl,0
        mov dh,rownum
        inc dh
        xor bh,bh
        mov ah,02h
        int 10h

;-- select menu item (up,down,tab,enter,esc)
hl_loop:mov ah,00h
        int 16h                 ;wait for kbd input (ah -scancode of the key)

        cmp ah,01h              ;Esc
        je  prFin
        cmp ah,1Ch              ;Enter
        je  edit
        cmp ah,48h              ;Up
        je  Up
        cmp ah,16h              ;"u"
        je  Up
        cmp ah,0Fh              ;Tab
        je  Down
        cmp ah,50h              ;Down
        je  Down
        cmp ah,20h              ;"d"
        je  Down
        cmp ah,3Dh              ;F3
        je  final
        cmp MbootCnt,0          ;MBR_main?
        je  p13                 ;--> if yes
        cmp ah,3Eh              ;F4
        je  f4
p13:    cmp ah,3Fh              ;F5
        je  f5
        jmp hl_loop

;-- move up highlighted menu line
Up:     cmp HighLighted,0
        jne p14
        mov HighLighted,4
p14:    dec HighLighted
        jmp pr_menu

;-- move down highlighted menu line
Down:   cmp HighLighted,3
        jne p15
        mov HighLighted,0
        jmp pr_menu
p15:    inc HighLighted
        jmp pr_menu

;-- enter new OS name into selected menu line
  ;-- invite to input
edit:   call clHelp
        mov dh,Help_y
        mov dl,Help_x
        lea si,EnterNew
        call prfld

  ;-- save cursor position (at the beginning of the input field)
        push dx

  ;-- clear input field
        mov cx,NameLng + 1
        lea di,osname_line+2
        mov al,' '
        rep stosb
        lea si,osname_line+2
        call prfld

  ;-- return cursor to the beginning of the input field
        pop dx
        xor bh,bh
        mov ah,02h
        int 10h

  ;-- input line
        mov ah,0Ah
        lea dx,osname_line
        int 21h

  ;-- remove <ODh> at the end of input
        lea si,osname_line+2
        mov cl,osname_line+1
        mov ch,0
        add si,cx
        mov byte ptr [si],' '

  ;-- copy input line into menu
        mov cx,NameLng
        lea si,osname_line+2
        mov ax,NameLng + 1
        mul HighLighted
        lea di,tmplNames
        add di,ax
        rep movsb
        jmp pr_menu

;-- set flags if F4 or F5 was pressed
f4:     mov F4flag,1
        jmp final
f5:     mov F5flag,1

;-- copy composed menu arrays into new MBR
final:  lea ax,tmplNames
        lea bx,tmplLengths
        lea bp,menuMb0

        mov dx,4
p16:    mov cx,NameLng
        mov si,ax
        mov di,bp
        rep movsb
        mov cx,LenLng
        mov si,bx
        rep movsb
        add ax,NameLng + 1
        add bx,LenLng + 1
        add bp,menuMb1 - menuMb0
        dec dx
        jnz p16

;-- copy base addresses into new MBR
        lea si,_rootBase
        lea di,rootBase
        mov cx,4
        rep movsw

;-- find extended partition in the part table and save its address
        lea bp,tbl
        mov cx,4
p17:    cmp byte ptr ds:(tblOs - tbl)[bp],05h   ;FAT16 extend
        je s1
        cmp byte ptr ds:(tblOs - tbl)[bp],0Fh   ;FAT32 extend
        je s1
        cmp byte ptr ds:(tblOs - tbl)[bp],85h   ;Linux extend
        je s1
        add bp,10h
        loop p17

        lea bp,tbl
        lea bx,menuMb0
        mov dx,4
p18:    mov cx,osnames$ - osnames - 1
        lea di,next_part
        mov si,bx
        repe cmpsb
        je s1
        add bx,menuMb1 - menuMb0
        add bp,10h
        dec dx
        jnz p18
        mov bp,0
s1:     mov extndPart,bp

;-- skip this MBR at user request
        cmp F5flag,0
        jne NextMb

;-- skip several actions if MBR_main is processed
        cmp MbootCnt,0
        je common

;-- set flag into MBR body if no bootable OS exist in it (for MBR_ext only)
        cmp F4flag,0
        je p19
        mov noOsFlag,1

;-- set Extended part as "active" (this is a default fot MBR_ext)
p19:    cmp extndPart,0
        je p20
        mov bp,extndPart
        mov ds:byte ptr [bp],80h

;-- apply a patch to skip 2-nd block loading (fot MBR_ext only)
p20:    lea si,patchA
        lea di,AddBlk
        mov cx,patchA$ - patchA
        rep movsb

;-- apply a patch if menu should appear by default at every boot
common: cmp NoKeyFlg,0
        je p22
        lea si,patchS
        lea di,Space
        mov cx,patchS$ - patchS
        rep movsb

;-- apply a patch if EDD mode should be used
p22:    cmp modeFlg,2
        jne p23
        lea si,patchE
        lea di,blRW_mb
        mov cx,patchE$ - patchE
        rep movsb

;-- save disc block (if it is required) before replacing it
p23:    mov si,word ptr Base
        mov di,word ptr Base + 2
        cmp NoBackupFlg,0
        jne p24
        call saveBlock

;-- write new MBR to the disc
p24:    lea bx,mboot
        mov ax,0300h
        call blRW
        jnc p25
        inc writErrFlg
        jmp prFin                       ;--> if write error
p25:    inc yesFlg

;-- calculate LBA of the next MBR_ext
NextMb: mov bp,extndPart
        cmp bp,0                        ;next MBR_ext exists?
        je prFin                        ;--> the End if no

        cmp MbootCnt,0                  ;MBR_main?
        jne bl1                         ;--> if no
        mov ax,ds:(tblLbn - tbl)[bp]
        mov word ptr _rootBase,ax
        mov word ptr _Base,ax
        mov ax,ds:(tblLbn - tbl + 2)[bp];     LBA of the first MBR_ext
        mov word ptr _rootBase + 2,ax   ;       --> _rootBase
        mov word ptr _Base + 2,ax       ;       --> _Base
        jmp bl2
bl1:    mov ax,ds:(tblLbn - tbl)[bp]
        mov dx,ds:(tblLbn - tbl + 2)[bp]
        add ax,word ptr _rootBase
        adc dx,word ptr _rootBase + 2
        mov word ptr _Base,ax           ;     LBA of the current MBR_ext
        mov word ptr _Base + 2,dx       ;       -->  _Base

bl2:    inc MbootCnt
        jmp mLoop                       ;--> continue mLoop


;======================= Print final messages =================================
;
prFin:  cmp clrScrFlg,0         ;has screen been cleared?
        je  prFin1              ;--> if no (print with scrolling)

;-- positional printing
        call clHelp
        mov dh,Help_y
        cmp yesFlg,0            ;has something been written onto the disc?
        je  pf01                ;--> if no
        mov dl,Help_x
        lea si,FinalMes1
        call prfld
        inc dh

pf01:   mov dl,Help_x
        lea si,hdReadErr+2
        cmp readErrFlg,0        ;disc read error?
        jne pf02                ;--> if yes
        lea si,hdWritErr+2
        cmp writErrFlg,0        ;disc write error?
        jne pf02                ;--> if yes
        cmp NoKeyFlg,0
        jne pf03
        lea si,FinalMes2
        cmp yesFlg,0            ;has something been written onto the disc?
        je  pf03                ;--> if no
pf02:   call prfld

pf03:   mov dh,rownum
        mov dl,0
        lea si,press_any+2      ;wait for key press
        call prfld
        mov ah,00h
        int 16h
        jmp exit

;-- print with scrolling
prFin1: cmp readErrFlg,0        ;disc read error?
        je  pf11                ;--> if no
        lea dx,hdReadErr
prErr:  mov ah,09h              ;print
        int 21h
        inc exit_code
pf11:   lea dx,press_any        ;wait for key press
        mov ah,09h              ;print
        int 21h
        mov ah,00h
        int 16h

;-- exit
exit:   mov al,exit_code
        mov ah,4Ch              ;ExitProcess
        int 21h

                IF $-Begin GT MBOOT_ORG
                .ERR
                ENDIF




;==================== Master Boot Record prototype ============================
;
                ORG     MBOOT_ORG
mboot:  cli
        xor    ax,ax
        mov    ss,ax                    ;ss <- 0
        mov    es,ax                    ;es <- 0
        mov    ds,ax                    ;ds <- 0
        mov    sp,7C00h                 ;sp <- 7c00h
        sti

;-- move MBR from 7c00h --> MBOOT_ORG
        cld
        mov    si,sp                    ;si <- 7c00h
        lea    di,mboot                 ;di <- MBOOT_ORG
        mov    cx,0100h
        repnz  movsw                    ;ds:si --> es:di
        jmp    cs:FAR PTR _cont

cont:
;-- load  2-nd block (for MBR_main only)
AddBlk: mov     bx,di   ;bx <- addr (800h)      ;patchA: lea    dx,AddBlk$
        mov     di,ax   ;di <- 0                ;        jmp    dx
        mov     si,1    ;di,si -block num       ;patchA$:
        mov     ah,02h
        call    blRW_mb                         ;
AddBlk$:

;-- find active partition
        xor     cx,cx           ;cl <- 0  (partition counter)
        lea     bp,tbl
m0:     cmp     [bp],ch
        jl      short m1        ;--> if found
        add     bp,10h
        inc     cx
        cmp     cx,4
        jb      m0
m1:     mov     ActPartNum,cl   ; cl>3 - if no active partition

;-- are ther bootable partitions in this MBR?
        cmp     noOsFlag,ch
        jne     short to_fin    ;--> if no bootable partitions (skip menu)

;-- check whether menu was requested (Spacebar was pressed)
Space:  cmp     SpacePressed,SPC_YES    ;was it pressed?       ;patchS: mov SpacePressed,SPC_YES
        je      short tobuild           ;-> if yes (build menu);        lea dx,Space$
        mov     ax,SPC_NO                                      ;        jmp dx
        cmp     SpacePressed,ax         ;was it NOT pressed?   ;patchS$:
        je      short  to_fin           ;-> if yes (next MBR or osBoot)

;-- at this point we don't know whether Spacebar was pressed or not
;    (this is true for MBR_main of the 1st disc)
        mov     DiscNumber,0            ;begin to count discs
        mov     SpacePressed,ax         ;suppose Spacebar was NOT pressed
        mov     ah,01h
        int     16h                     ;check whether it was pressed
        jz      short to_fin            ;--> if no key was pressed
        cmp     al,' '
        jne     short to_fin            ;some key was pressed but not Spacebar
        mov     SpacePressed,SPC_YES    ;mark that Spacebar was pressed
Space$:
tobuild:jmp     build                   ;--> to print menu
to_fin: jmp     fin                     ;--> to load next MBR or osBoot

                IF $-mboot GT 0DAh
                .ERR
                ENDIF

                ORG     MBOOT_ORG + 0DAh
        db      6 DUP (0FFh)    ;  ;    - 
                                ; ᪠ (80h-...)  ६  2-10 

menuMb          DB      'Disc '                 ;06E0
menuMb_         label   byte
CurrDiscMenu    DB      '0',0
                DB      0
                DB      '1. '
menuMb0         DB      NameLng DUP (' ')
                DB      LenLng  DUP (' ')
                DB      ' mb',0
                DB      '2. '
menuMb1         DB      NameLng DUP (' ')
                DB      LenLng  DUP (' ')
                DB      ' mb',0
                DB      '3. '
                DB      NameLng DUP (' ')
                DB      LenLng  DUP (' ')
                DB      ' mb',0
                DB      '4. '
                DB      NameLng DUP (' ')
                DB      LenLng  DUP (' ')
                DB      ' mb',0
                DB      0
 menuMbEnd      DB      'Enter partition:',0
                DB      0
                DB      '  0 - next disc',0
                DB      '$'
 menuMbEnd_     label   byte



;-- read/write 1 block  (MBR)   (for Int 13 Extended see: patchE)
;   ah - OpCode (02h,03h)
;di,si - lba
;   bx - BuffAddr
blRW_mb:push   ax
        mov    ax,si
        mov    dx,di            ;dx,ax <- lba

        div    SecsInCyl        ;ax <- cyl number
        mov    cx,ax            ;cx <- save cyl number
        shl    ch,6             ;ch <- 2 high bits of cyl number
        jnc    short m2
        jmp    $                ;error if cyl number > 1023
m2:     mov    ax,dx
        xor    dx,dx
        div    SecsInHead       ;al <- head number; dl - sect. number
        inc    dl
        xor    ch,dl            ;ch <- 2 high cil bits + sect number
        xchg   ch,cl
        mov    dh,al            ;dh <- head number
        pop    ax
        mov    al,1             ;number of blocks to transfer
        mov    dl,80h
        or     dl,DiscNumber
        int    13h
        ret
blRW_mb$:

VarAreaSize     =       10h
                IF $ - mboot GT (01BEh - VarAreaSize)
                .ERR
                ENDIF
                ORG     MBOOT_ORG + (01BEh - VarAreaSize)

BegOfVars       label   near
ActPartNum      DB      0       ;(0-4) =4, if no act part in table (disc change)
noOsFlag        DB      0       ;=1, if no bootable OS in part table
extndPart       DW      0       ;Extended partition address in part table or 0
rootBase        DD      0       ;LBA of the first MBR_ext
Base            DD      0       ;LBA of this MBR_ext
SecsInCyl       DW      0
SecsInHead      DW      0

ParTable        label   near
                IF (ParTable - BegOfVars) NE VarAreaSize
                .ERR
                ENDIF
                                ;----- Partition Table -----------
tbl             DB      0       ;Active
tblHead         DB      0       ;BegHead
tblCyl          DW      0       ;BegCylSect
tblOs           DB      0       ;OS
                DB      0       ;EndHead
                DW      0       ;EndCylSect
tblLbn          DD      0       ;BegLBN
tblSize         DD      0       ;Size (in blocks)

$gen<           DB      3*16 DUP (0)>   ;2-4 partitions
Mark            DW      0AA55h

;============= 2-nd block of MBR_main (common part for all MBRs) ==============
;              incuded only into MBR_main
;
;-- clear screen
build:  mov     ax,0600h                ;al=0 (entire screen)
        xor     cx,cx                   ;upper left corner  (row=00,col=00)
        mov     dx,1850h                ;lower right corner (row=25,col=80)
        mov     bh,07h                  ;color
        int     10h

;-- print menu
        mov     al,DiscNumber
        inc     al
        or      al,'0'
        mov     CurrDiscMenu,al
        mov     dx,Menu_xy              ;dx - menu coordinates
        lea     si,menuMb
m3:     call    prt                     ;print menu line
        inc     dh                      ;next line
        mov     dl,Menu_x
        cmp     byte ptr [si],'$'       ;end of menu?
        jne     m3                      ;--> if no

;-- clear all active marks in part table
        mov     cl,4
        lea     di,tbl
m4:     mov     [di],ch
        add     di,10h
        loop    m4

;-- ask to define active partition
        mov     ActPartNum,4            ;set default value (no active partition)
m5:     mov     ah,ch
        int     16h
        cmp     al,' '                  ;if repeated Spaces --> continue
        je      m5

        cmp     al,'0'
        je      short writeMb           ;"0" - go to next disc
        and     al,0Fh
        cmp     al,4
        ja      m5                      ;if (al > 4) --> continue
        dec     al
        mov     ActPartNum,al           ;active partition has been defined

;-- mark chosen partition as active
        shl     al,4
        xor     ah,ah
        lea     bp,tbl
        add     bp,ax
        mov     byte ptr [bp],80h

;-- return current MBR into disc
writeMb:mov     ah,03h
        mov     si,word ptr Base
        mov     di,word ptr Base + 2
        lea     bx,mboot
        call    blRW_mb

;-- load osBoot                         ||
;        MBR_ext of the current disc    ||
;        MBR_main of the next disc
fin:    xor     ax,ax
        cmp     ActPartNum,4            ;does current MBR have active partition?
        jb      nextMb                  ;--> if yes

;-- change disc (no active partition)
        inc     DiscNumber              ;increment disc number
        mov     cl,ds:MaxDrives
        cmp     DiscNumber,cl           ;more than total number of disc drives?
        jb      m6                      ;--> if no
        mov     DiscNumber,al           ;begin to count drives from 0
m6:     mov     si,ax
        mov     di,ax                   ;lba = 0
        jmp     readMb                  ;--> to get MBR_main of the next disc

;-- calculate LBA of the next MBR_ext (or osBoot)
;       (for MBR_main:  Base == rootBase == 0)
nextMb: mov     si,word ptr rootBase    ;suppose MBR_ext should be loaded
        mov     di,word ptr rootBase + 2;
        cmp     bp,extndPart            ;really so?
        je      short m7                ;--> if yes (the chain is continuing)

        mov     si,word ptr Base        ;osBoot should be loaded (end of chain)
        mov     di,word ptr Base + 2    ;
        mov     SpacePressed,0          ;in case this mark would not be cleared
                                        ;    whith reboot
m7:     add     si,(tblLbn - tbl)[bp]
        adc     di,(tblLbn - tbl + 2)[bp]

;-- read osBoot or MBR into 7C00h
readMb: mov     ah,02h
        mov     bx,7C00h
        call    blRW_mb

;-- check whether Mark is present
        cmp    word ptr (Mark - mboot)[bx],0AA55h
        jne    build

;--> to osBoot
        jmp     FAR PTR _boot

;-- print text (0 -end of the text)
;   ds:si - text address (exit with: ds:si -incremented)
;   dh,dl - cursor position (row,col) (exit with dl -incremented)
prt:    push   cx
prt1:   mov    ah,02h
        mov    bx,07h           ;video page number(bh) + attr(bl)
        inc    dl
        int    10h              ;set cursor position
        lodsb                   ;ds:(si)+ --> al
        cmp    al,00h           ;end of text?
        je     short prtExit    ;--> if yes
        mov    cx,1             ;repeat count
        mov    ah,09h           ;output 1 char
        int    10h
        jmp    short prt1       ;--> next char
prtExit:pop    cx
        ret

                IF $-mboot GT 400h
                .ERR
                ENDIF

                ORG     FREE_ORG
SpacePressed    DW      0       ;MBR_main of disc #0 writes SPC_YES or SPC_NO,
                                ; other MBRs only read this flag.
DiscNumber      DB      0       ;this is incremented by disc change; cleared
                                ; before running osBoot


;===============================  Subroutines  ================================
;
;-- Read/Write one block (or two blocks for MBR_main)
;   ax - Op Code (0200h or 0300h)
;ds:bx - buffer address
;si,di - absolute block number (lba)

blRW:   pusha
        mov tmp,1               ;suppose we should transfer 1 block
        mov cx,si
        or cx,di                ;MBR_main?
        jne p40                 ;--> if no
        inc tmp                 ;2 blocks for MBR_main
p40:    mov dl,CurrDisc         ;dl - disc id
        cmp modeFlg,2           ;EDD mode?
        jne blRW1               ;--> if no

;-- EDD mode
 ;- set starting absolute block number
        xor cx,cx
        push cx
        push cx
        push di
        push si

 ;- set transfer buffer address
        push ds
        push bx

 ;- set number of blocks to transfer
        push tmp

 ;- set packet size
        push 10h

 ;- set packet address (ds:si)
        mov si,sp
        push ds
        push ss
        pop ds

 ;- transfer
        or  ah,40h
        int 13h
        pop ds
        lea sp,[si+10h]
        jmp blRW_ex

;-- CHS mode
blRW1:  push ax                 ;save OPcode
        push dx                 ;save disc id
        mov ax,si
        mov dx,di               ;dx,ax - LBA
        pop di                  ;di <- disc id
        pop si                  ;si <- OPcode

        div SecsInCyl           ;ax <- cyl number
        mov cx,ax               ;cx <- cyl number
        shl ch,6                ;ch <- 2 high bits of cyl number
        jc blRW_ex              ;error if cyl number > 1023
        mov ax,dx
        xor dx,dx
        div SecsInHead          ;al <- head number; dl - sect. number
        inc dl                  ;sect numbers start from 1
        xor ch,dl               ;ch <- 2 high cil bits + sect number
        xchg ch,cl
        mov dx,di               ;dl <- disc id
        mov dh,al               ;dh <- head number
        mov ax,si               ;ah <- OPcode
        mov al,byte ptr tmp     ;al <- block count (1 or 2)
        push es
        push ds
        pop es                  ;es:bx <- buffer address
        int 13h
        pop es

blRW_ex:popa
        ret


;-- write MBR into a file
;   name of the file is constructed as:  ffffffff.nnn
;        where:              ffffffff    - lba of an MBR (in hex code)
;                            nnn         - hard disc number (001-...)
;input:
;si,di - absolute block number
;
saveBlock:
 ;-- construct file name body
        pusha
        mov cx,8
        mov dx,si
        mov ax,di
        lea bx,file_name
sbName: push ax
        shr ax,12
        or al,30h
        cmp al,39h
        jbe p41
        add al,7
p41:    mov [bx],al
        inc bx
        pop ax
        shld ax,dx,4
        shl dx,4
        loop sbName

 ;-- construct file name extention
        mov al,CurrDisc
        and al,0Fh
        inc al
        or 3[bx],al

 ;-- create file
        lea dx,file_name
        mov ax,3D00h                    ;open file
        int 21h
        jnc sbExit                      ;-> if this block has been once saved
        lea dx,openErr
        cmp ax,02h                      ;file is not found?
        jne prErr                       ;no (other error)

        lea dx,file_name                ;ds:dx <- file name addr
        mov cx,0                        ;wAttribute
        mov ah,3Ch                      ;create file
        int 21h
        lea dx,creatErr
        jc prErr                        ;--> if not created
        mov bp,ax                       ;bp <- file handler

  ;-- read MBR which is bound to save
        lea bx,buff                     ;bx <- buff addr
        mov ax,0200h
        call blRW
        jnc p42                         ;--> if OK
        inc readErrFlg
        jmp prFin                       ;--> if disc read error

 ;-- write it to created file
p42:    mov bx,bp                       ;bx <- file handler
        mov cx,DiscBlockSize            ;cx <- byte count
        cmp MbootCnt,0                  ;MBR_main?
        jne p43                         ;--> if no (transfer i block)
        mov cx,DiscBlockSize*2          ; 2 blocks for MBR_main
p43:    lea dx,buff                     ;ds:dx <- buff addr
        mov ah,40h                      ;write to the file
        int 21h
        lea dx,writeErr
        jc prErr                        ;--> if disc write error
sbExit: mov ah,3Eh                      ;close file
        int 21h
        popa
        ret


;-- fill OS name field of menu with default OS name
;    si - destination address (data filled from left to right)
;    bp - partition table address
fill_osname:
        pusha
        mov di,si                       ;di <- dest addr
        lea si,osnames                  ;si <- table of known OS names
        mov al,ds:(tblOs - tbl)[bp]     ;al <- OS type
d1:     cmp al,[si]                     ;this OS type?
        je d2                           ;--> if yes
        add si,osnames$ - osnames       ;check next name
        cmp byte ptr [si],0FFh          ;end of the table
        jne d1                          ;--> if no
d2:     inc si
        mov cx,osnames$ - osnames - 1
        rep movsb                       ;fill OS name field
        popa
        ret


;-- fill OS length field of menu
;    si - destination address (data filled from right to left)
;    bp - partition table address
fill_len:
        pusha
        mov di,10
        mov ax,ds:(tblSize - tbl)[bp]
        mov dx,ds:(tblSize - tbl + 2)[bp]       ;dx,ax -size in blocks
        mov cx,2048                             ;1024*1024/DiscBlockSize
        div cx                                  ;ax -size in MBytes
        cmp dx,1024
        jb f1
        inc ax                                  ;round it up

;-- convert to decimal
f1:     xor dx,dx
        div di
        xor dl,30h
        mov [si],dl
        dec si
        and ax,ax
        jnz f1
        popa
        ret


;-- print text at cursor position ($ -end of text)
;   ds:si - text address
;   dx    - cursor position (dh -row; dl -col)
;   di    - menu line number (check if it needs to be highlighted)
; exit:  - incremented si and dl (text pointer and column)
prfld:  mov di,-1               ;no highlight for this entry
prHfld: push cx
        xor bh,bh
pr_loop:mov ah,02h
        int 10h                 ;set cursor
        lodsb                   ;ds:(si)+ --> al
        cmp al,'$'              ;end of text?
        je pr_end               ;--> if yes
        mov cx,1                ;repeat count for int 10h
        mov bl,07h              ;direct color
        cmp di,HighLighted      ;needs to be highlighted?
        jne g1                  ;--> if no
        mov bl,70h              ;inverse color
g1:     mov ah,09h              ;ah - output one char
        int 10h
        inc dl
        jmp pr_loop
pr_end: pop cx
        ret


;-- clear lower part of the screen (where help messages are printed)
clHelp: pusha
        mov ch,Help_y
        mov cl,0
        mov dh,rownum
        mov dl,colnum
        call clWin
        popa
        ret


;-- clear last two lines of the screen (where diag. messages are printed)
clDiag: pusha
        mov ch,rownum
        dec ch
        mov cl,0
        mov dh,rownum
        mov dl,colnum
        call clWin
        popa
        ret


;-- clear window
;   cx - upper left corner of the window (row,col)
;   dx - lower right corner of the window(row,col)
clWin:  pusha
        mov bh,07h                      ;color attr of the scrolled window
        mov ax,0600h                    ;al=0 (scroll entire window)
        int 10h
        popa
        ret


;===================== MBR patches ===========================================
;
;-- skip loading second block (for MBR_ext)
patchA: lea dx,AddBlk$
        jmp dx
patchA$:

;-- don't check key pressing
patchS: mov SpacePressed,SPC_YES
        lea dx,Space$
        jmp dx
patchS$:

;-- disc transfer in EDD mode
patchE: xor cx,cx
        push cx                         ;- starting
        push cx                         ;  absolute
        push di                         ;  block
        push si                         ;  number

        push cx                         ;- transfer
        push bx                         ;  buffer

        push 1                          ;number of blocks to transfer
        push 10h                        ;size of packet
        mov si,sp
        mov dl,80h
        or dl,DiscNumber
        or ah,40h
        mov al,0                        ;no flags
        int 13h
        lea sp,[si+10h]
        ret
patchE$:


;============================= Messages =======================================
;
$gen <legend    DB      "Boot Manager Installation program   Version 1.0   11-07-2001",0Dh,0Ah,'$'>

$gen <ask_drive DB      0Dh,0Ah,"Select physical disc to install Boot Manager (1-">
$gen <maxdrives DB      "0) [1]$">

$gen <press_any DB      0Dh,0Ah,'Press any key to continue$'>

$gen <protErr   DB      0Dh,0Ah,"Run this program under Dos v3.x or higher$">
$gen <hdReadErr DB      0Dh,0Ah,"Can't read from HDD$">
$gen <hdWritErr DB      0Dh,0Ah,"Can't write master boot record to HDD$">
$gen <hdprmErr  DB      0Dh,0Ah,"Can't get HDD params$">
$gen <openErr   DB      0Dh,0Ah,"Can't open file$">
$gen <creatErr  DB      0Dh,0Ah,"Can't create file$">
$gen <seekErr   DB      0Dh,0Ah,"Can't seek file$">
$gen <writeErr  DB      0Dh,0Ah,"Can't write to file$">

$gen <options   DB      0Dh,0Ah,"Options are: ",0Dh,0Ah>
$gen <          DB      "  /n    -skip MBR backup",0Dh,0Ah>
$gen <          DB      "  /c    -force using Cyls/Heads/Sects mode",0Dh,0Ah>
$gen <          DB      "  /e    -force using Enhanced Disc Drive mode",0Dh,0Ah>
$gen <          DB      "  /m    -menu appears at every boot",0Dh,0Ah>
$gen <          DB      "           (otherwise spacebar should be pressed)",0Dh,0Ah>
                DB      0Dh,0Ah
$gen <          DB      "  Known extended partition types are:",0Dh,0Ah>
$gen <          DB      "      05h - FAT16 extended",0Dh,0Ah>
$gen <          DB      "      0fh - FAT32 extended",0Dh,0Ah>
$gen <          DB      "      85h - Linux extended",0Dh,0Ah>
                DB      0Dh,0Ah
$gen <          DB      "   to mark extended partition in the menu",0Dh,0Ah>
$gen <          DB      "   you may also enter:  '--> next   '",0Dh,0Ah>
$gen <          DB      "   as a partition name",0Dh,0Ah>
                DB      '$'

$gen <noExt     DB      0Dh,0Ah,0Dh,0Ah,"Int 13 Extended is not supported by your BIOS on disc ">
CurrDiscNum1    DB      '0.',0Dh,0Ah,'$'

$gen <EnterNew  DB      "Enter new OS name for this partition: $">
$gen <PressUp   DB      "Up,Down,Enter - edit menu$">
$gen <PressEsc  DB      "Esc - exit$">
$gen <PressF3   DB      "F3  - save$">
$gen <PressF3_  DB      " (the list HAS bootable partitions)$">
$gen <PressF4   DB      "F4  - save (the list DOESN'T HAVE bootable partitions)$">
$gen <PressF5   DB      "F5  - skip$">
$gen <FinalMes1 DB      "New master boot record(s) has been saved on disc ">
CurrDiscNum2    DB      '0$'
$gen <FinalMes2 DB      "Press spacebar during boot process to activate menu$">


;===============================  Tables =====================================
;
;-- known OS names
osnames         DB      00h,'not used   '
osnames$        DB      05h
next_part       DB      '--> next   '
                DB      06h,'FAT16      '
                DB      07h,'WinNT      '
                DB      09h,'OS-9000    '
                DB      0Bh,'FAT32      '
                DB      0Fh,'--> next   '
                DB      83h,'Linux      '
                DB      82h,'Linux Swap '
                DB      85h,'--> next   '
                DB     0FFh,'unknown    '


;===============================  Variables and arrays  =======================
;
tmp             DW      0
exit_code       DB      0

CurrDisc        DB      80h     ;current disc id in BIOS format
MbootCnt        DB      0       ;count of MBR processed
readErrFlg      DB      0       ;disc read error flag
writErrFlg      DB      0       ;disc write error flag
rownum          DB      0       ;saves RowNum DOS variable
colnum          DB      0       ;saves ColNum DOS variable
NoBackupFlg     DB      0       ;=1 if program invoked with /n switch
NoKeyFlg        DB      0       ;=1 if program invoked with /m switch
modeFlg         DB      0       ;0 -auto 1-CHS 2-EDD (/c or /e switches)
F4flag          DB      0       ;=1 if F4 was pressed (skip MBR at boot time)
F5flag          DB      0       ;=1 if F5 was pressed (don't save MBR at all)
yesFlg          DB      0       ;=1 if at least one of the MBRs has been modified on disc
clrScrFlg       DB      0       ;=1 if the screen has been already cleared
MenuInstalled   DB      0       ;=1 if OS names from old MBR have been used
NumAddr         DW      0       ;-|
OsAddr          DW      0       ; | current addresses when printing menu fields
LenAddr         DW      0       ;-|
HighLighted     DW      0
_rootBase       DD      0       ;LBA of the first MBR_ext
_Base           DD      0       ;LBA of the current MBR
file_name       DB      8 dup (30h)     ;
                DB      '.'             ; name of a file
                DB      3 dup (30h)     ; to backup MBR sector
                DB      0               ;

;-- buffer for disc number input
line            DB      2,0,0,0

;-- buffer for OS name input
osname_line     DB      NameLng + 1,0,(NameLng + 1) dup (' '),'$'

;-- arrays for menu composition
tmplNums        DB      '1.  ','$'
                DB      '2.  ','$'
                DB      '3.  ','$'
                DB      '4.  ','$'
tmplNames       DB      NameLng DUP (' '),'$'
                DB      NameLng DUP (' '),'$'
                DB      NameLng DUP (' '),'$'
                DB      NameLng DUP (' '),'$'
tmplLengths     DB      LenLng  DUP (' '),'$'
                DB      LenLng  DUP (' '),'$'
                DB      LenLng  DUP (' '),'$'
                DB      LenLng  DUP (' '),'$'
endline         DB      ' mb','$'

;-- buffer for Int 13-48 (Get Drive Parameters) (not used)
discParams      DPRMS   <>

;-- buffer for disc transfer ops
$gen<buff       DB      400h DUP (0)>
mainSeg         ENDS


;=============================== Tell MASM where labels lie ===================
;
.8086           ;otherwise MASM goes into the 32 bit mode when far jumps
atSeg           SEGMENT         at 0000h
                ASSUME          cs:atSeg    ;this too MASM needs to have

                ORG             44Ah
ColNum          label           word
                ORG             475h
MaxDrives       label           byte
                ORG             484h
RowNum          label           byte
                ORG             MBOOT_ORG + (cont - mboot)
_cont           label           far
                ORG             7C00h
_boot           label           far
atSeg           ENDS

progstack       SEGMENT         para stack 'stack'
                ORG 200h
progstack       ENDS
                END Begin
